
0000            00010  ;Random Plot routine
0000            00020  ;by Jim Grimwood 2005
0000            00030  ;RND is taken from the ROM
0000            00040  ;routine S_RND at 25F8
0000            00050  ;RNDQ/RANDOM routines are
0000            00060  ;by Toni Baker ZX Computing,1986
0000            00070  ;Program uses RND or RNDQ via
0000            00080  ;call at LOOP1+1
0000            00090  ;
0000            00100  ;Using OCP Editor/Assembler
0000            00110  ;
0000            00120  ;Start by checking for a
0000            00130  ;parameter on the calc.stack
0000            00140         org  65000
FDE8 01635C     00150  R_PLOT ld   bc,STKBOT
FDEB 21655C     00160         ld   hl,STKEND
FDEE 0A         00170         ld   a,(bc)
FDEF BE         00180         cp   (hl)
FDF0 2005       00190         jr   nz,GO
FDF2 03         00200         inc  bc
FDF3 23         00210         inc  hl
FDF4 0A         00220         ld   a,(bc)
FDF5 BE         00230         cp   (hl)
FDF6 C8         00240         ret  z
FDF7            00250  ;Get parameter; RET if too big
FDF7 CDA22D     00260  GO     call FPTOBC
FDFA D8         00270         ret  c
FDFB 78         00280  LOOP0  ld   a,b
FDFC B1         00290         or   c
FDFD C8         00300         ret  z
FDFE 0B         00310         dec  bc
FDFF C5         00320         push bc
FE00 3E0A       00330         ld   a,0Ah
FE02 F5         00340  LOOP1  push af
FE03 CD45FE     00350         call RNDQ
FE06            00360  ;RND/RNDQ puts a random number
FE06            00370  ;>=0 and <1 on calc.stack
FE06 EF         00380  CALC2  rst  28h
FE07            00390  ;stk_data 45056 (RND,45056)
FE07            00400  ;45056=B000h
FE07 3480B000   00410         defb 34h,80h,0b0h,00
FE0B 00B0       00420         defb 00,0b0h
FE0D            00430  ;multiply (RND*45056)
FE0D 04         00440         defb 04
FE0E            00450  ;int (r=INT(RND*45056))
FE0E 27         00460         defb 27h
FE0F            00710  ;end_calc
FE0F 38         00720         defb 38h
FE10 CDA22D     00730         call FPTOBC
FE13            00740  ;BC contains YX coordinates
FE13 CDE522     00750         call PLOT+9
FE16 F1         00760         pop  af
FE17 3D         00770         dec  a
FE18 20E8       00780         jr   nz,LOOP1
FE1A C1         00790         pop  bc
FE1B 18DE       00800         jr   LOOP0
FE1D            00810  ;
FE1D            00820  ;
FE1D            00830  ;Put a pseudo-random number
FE1D            00840  ;>=0 and <1 on calc.stack
FE1D            00850  ;A. Standard ROM method
FE1D ED4B765C   00860  RND    ld   bc,(SEED)
FE21 CD2B2D     00870         call STK_BC
FE24 EF         00880         rst  28h
FE25 A10F3437   00890         defb 0a1h,0fh,34h,37h,16h
FE29 16
FE2A 04348041   00900         defb 04h,34h,80h,41h
FE2E 00008032   00910         defb 00,00,80h,32h,02
FE32 02
FE33 A1033138   00920         defb 0a1h,03,31h,38h
FE37 CDA22D     00930         call FPTOBC
FE3A ED43765C   00940         ld   (SEED),bc
FE3E 7E         00950         ld   a,(hl)
FE3F A7         00960         and  a
FE40 C8         00970         ret  z
FE41 D610       00980         sub  10h
FE43 77         00990         ld   (hl),a
FE44 C9         01000         ret
FE45            01010  ;
FE45            01020  ;B. Toni Baker's quicker method
FE45 CD57FE     01030  RNDQ   call RANDOM
FE48 44         01040         ld   b,h
FE49 4D         01050         ld   c,l
FE4A CD2B2D     01060         call STK_BC
FE4D EF         01070         rst  28h
FE4E 3D38       01080         defb 3dh,38h
FE50 7E         01090         ld   a,(hl)
FE51 A7         01100         and  a
FE52 C8         01110         ret  z
FE53 D610       01120         sub  10h
FE55 77         01130         ld   (hl),a
FE56 C9         01140         ret
FE57            01150  ;
FE57            01160  ;Calc. next pseudo-random SEED
FE57 2A765C     01170  RANDOM ld   hl,(SEED)
FE5A 7C         01180         ld   a,h
FE5B A5         01190         and  l
FE5C 3C         01200         inc  a
FE5D 2005       01210         jr   nz,RAND_2
FE5F 21B5FF     01220         ld   hl,0ffb5h
FE62 182A       01230         jr   RANDEX
FE64 AF         01240  RAND_2 xor  a
FE65 23         01250         inc  hl
FE66 54         01260         ld   d,h
FE67 5D         01270         ld   e,l
FE68 29         01280         add  hl,hl
FE69 8F         01290         adc  a,a
FE6A 29         01300         add  hl,hl
FE6B 8F         01310         adc  a,a
FE6C 29         01320         add  hl,hl
FE6D 8F         01330         adc  a,a
FE6E 19         01340         add  hl,de
FE6F CE00       01350         adc  a,00
FE71 29         01360         add  hl,hl
FE72 8F         01370         adc  a,a
FE73 29         01380         add  hl,hl
FE74 8F         01390         adc  a,a
FE75 19         01400         add  hl,de
FE76 CE00       01410         adc  a,00
FE78 29         01420         add  hl,hl
FE79 8F         01430         adc  a,a
FE7A 19         01440         add  hl,de
FE7B CE00       01450         adc  a,00
FE7D 24         01460         inc  h
FE7E 25         01470         dec  h
FE7F 2006       01480         jr   nz,RANMOD
FE81 BD         01490         cp   l
FE82 2803       01500         jr   z,RANMOD
FE84 3801       01510         jr   c,RANMOD
FE86 3D         01520         dec  a
FE87 5F         01530  RANMOD ld   e,a
FE88 1600       01540         ld   d,00
FE8A A7         01550         and  a
FE8B ED52       01560         sbc  hl,de
FE8D 2B         01570         dec  hl
FE8E 7C         01580  RANDEX ld   a,h
FE8F 22765C     01590         ld   (SEED),hl
FE92 C9         01600         ret
FE93            01610  ;
FF58            01620  UDGLOC equ  65368
FE93            01630  ;ROM routines
2DA2            01640  FPTOBC equ  2da2h
22DC            01650  PLOT   equ  22dch
2D2B            01660  STK_BC equ  2d2bh
FE93            01670  ;System variables
5C78            01680  FRAMES equ  23672
5C76            01690  SEED   equ  23670
5C63            01700  STKBOT equ  23651
5C65            01710  STKEND equ  23653

00000 TOTAL ERRORS

CALC2        FE06                       FPTOBC       2DA2
FRAMES       5C78                       GO           FDF7
LOOP0        FDFB                       LOOP1        FE02
PLOT         22DC                       RANDEX       FE8E
RANDOM       FE57                       RAND_2       FE64
RANMOD       FE87                       RND          FE1D
RNDQ         FE45                       R_PLOT       FDE8
SEED         5C76                       STKBOT       5C63
STKEND       5C65                       STK_BC       2D2B
UDGLOC       FF58
